// --- [ fdti.c ] -------------------------------------------------------------
//
// tab = 3
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "ftd2xx.h"
#include <dos.h>
#include <time.h>
#include "xbee_api.h"
#include "global.h"

#ifdef IS_CONIO2_LIB
	#include <conio2.h>
#endif

void rs232_api_write(unsigned char* data_out);
//void rs232_read(int waiting_for_ACK);
void GetDevice_Status(void);
unsigned int SetDevice_Baudrate(void);

// ----------------------------------------------------------------------------
// Schreibt ein vorbereitetes API-Frame via FTDI-USB-Seriell Adapter raus
void rs232_api_write(unsigned char* data_out)
{
DWORD data_len;
DWORD data_written, dwErr;

data_len = data_out[2] + (3 + 1);               // + (Start + Lnge) + Prfbyte

ftStatus = FT_Write(ftHandle, data_out, data_len, &data_written);

if (!(ftStatus == FT_OK))
	{
	dwErr = GetLastError();

#ifdef IS_CONIO2_LIB
	textcolor(LIGHTRED);
#endif
	printf("\n\nWrite Failed: %X", (int)dwErr);

#ifdef IS_CONIO2_LIB
	textcolor(LIGHTCYAN);
#endif
	}

else if (verbosed)
	{
	printf("\n\nBytes tx: %X ", (int) data_written);
   if (const_frame_id_0) printf("Frame_ID: 0 - no response will be sent!");
   else printf("Frame_ID: %X", last_frame_id);
	}
}

// ----------------------------------------------------------------------------
// liest jeweils Byte-Gruppen via serieller Schnittstelle ein.
// wenn mindestens 3 Byte gelesen sind, wird die Lnge der Nachricht aus rs232_in[2]
// bestimmt.
// Sind alle erwarteten Bytes eingetroffen, dann wird beendet.

// Gibt einen ber die serielle Schnittstelle empfangenen Datensatz aus
// die Daten stehen in rs232_in[]
void rs232_print_received(unsigned int bytes, unsigned int last_byte)
{

unsigned int i, j;

#ifdef IS_CONIO2_LIB
	textcolor(YELLOW);
#endif

if (verbosed)
	{
	if (rs232_in[0] != FIRST_CHR) printf("\n\nNo Start Delimiter 0x7E");
	printf("\n\nBytes rx: %X ", bytes);
	if (bytes == last_byte)	printf("- Frame complete !"); else printf("- more than 1 Frame");
	}

if (verbosed == 2)
	{
	if (bytes > 0)
		{
		printf("\n");
   	for (i = 0; i < bytes; i++)            // alle empfangenen Daten ausgeben
      	{
      	printf("%X ",  rs232_in[i]); // die Daten ausgeben
      	}
      //	if (test_checksum(&rs232_in[0]) > 0) printf(". crc ok");else printf(". crc error");
		if (test_checksum(&rs232_in[0]) == FALSE) printf(". crc error");
   	}
	}

j = i = 0;

while (i < bytes)
	{
	if ((rs232_in[j] == FIRST_CHR) && (rs232_in[i+1] == 0) && (i <= bytes))
		{
		i += rs232_in[j+2] + 4;          // Start des nchsten Frames
		if      (rs232_in[j+3] == 0x88) frame88(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x8A) frame8A(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x8B) frame8B(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x90) frame90(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x92) frame92(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x95) frame95(&rs232_in[j]);
		else if (rs232_in[j+3] == 0x97) frame97(&rs232_in[j]);
		else printf("\nFrame Type %X unknown\n\n", rs232_in[j+3]);
		j = i;
		}
	}
}

// ----------------------------------------------------------------------------
// Fragt den RX- und TX-Buffer ab
void GetDevice_Status(void)
{
DWORD rx_queue, tx_queue, event;
ftStatus = FT_GetStatus(ftHandle, &rx_queue, &tx_queue, &event);

if (ftStatus == FT_OK)
	{
	printf("Status: RX: %d TX: %d Event: %d " , (int) rx_queue, (int) tx_queue, (int) event);
	}
else
	{
	printf(" Status: Error ");
	}
}

// ----------------------------------------------------------------------------
// Fragt den Status ab und
// liefert die Anzahl der anstehenden Bytes zurck
DWORD GetRx_Bytes(void)
{
DWORD rx_queue, tx_queue, event;
ftStatus = FT_GetStatus(ftHandle, &rx_queue, &tx_queue, &event);

if (ftStatus == FT_OK) return(rx_queue); else return(0);
}

// ----------------------------------------------------------------------------
// Holt die Device-Bezeichnung
// Public sind: ftHandle, ftStatus
void GetDevice_Info(void)
{
FT_DEVICE ftDevice;
DWORD deviceID;
char SerialNumber[16];
char description[64];

ftStatus = FT_GetDeviceInfo(ftHandle, &ftDevice, &deviceID, SerialNumber, description, NULL);
if (ftStatus == FT_OK)
	{
	printf("\nUSB-Device : ");

	if      (ftDevice == 0) printf("FTU232BM");
	else if (ftDevice == 1) printf("FT232AM");
	else if (ftDevice == 2) printf("FT8100AX");
	else if (ftDevice == 3) printf("FT2232C/L/D");
	else if (ftDevice == 5) printf("FT232R");
	else if (ftDevice == 6) printf("FT2232H");
	else if (ftDevice == 7) printf("FT4232H");
   else printf("unbekannt");

	printf("\nDescription: %s\n", description);
	}

else
	{
	printf("\nDevice-Info failed\n");
	}
}

// ----------------------------------------------------------------------------
// Setzt die bertragungsparameter auf 9600 Baud, 1 Stop-Bit, keine Paritt
unsigned int SetDevice_Baudrate(void)
{
unsigned int success = TRUE;

	ftStatus = FT_SetBaudRate(ftHandle, 9600);
	if (!(ftStatus == FT_OK))
		{
		printf("SetBaudrate failed");
		success = FALSE;
		}
	ftStatus = FT_SetDataCharacteristics(ftHandle, FT_BITS_8, FT_STOP_BITS_1, FT_PARITY_NONE);
	if (!(ftStatus == FT_OK))
		{
		printf("\nCharacteristics failed\n");
		success = FALSE;
		}

	ftStatus = FT_SetTimeouts(ftHandle, 100, 100);
	if (ftStatus != FT_OK) printf("\nTimeout failed\n");

	if (success) printf("\n9600 Baud, 1 Stop-Bit, no Parity\n");
	return(success);
}

// --- [ eof ] ----------------------------------------------------------------
